Index: bfd/elf32-m32r.c
===================================================================
RCS file: /cvs/src/src/bfd/elf32-m32r.c,v
retrieving revision 1.38
diff -c -r1.38 elf32-m32r.c
*** bfd/elf32-m32r.c	3 Dec 2003 17:38:48 -0000	1.38
--- bfd/elf32-m32r.c	18 Dec 2003 10:04:33 -0000
***************
*** 2122,2131 ****
  #define elf_backend_gc_sweep_hook               m32r_elf_gc_sweep_hook
  #define elf_backend_check_relocs                m32r_elf_check_relocs
  
  #define elf_backend_can_gc_sections             1
! #if !USE_REL
  #define elf_backend_rela_normal			1
  #endif
  #if 0 /* not yet */
  /* relax support */
  #define bfd_elf32_bfd_relax_section		m32r_elf_relax_section
--- 4758,4792 ----
  #define elf_backend_gc_sweep_hook               m32r_elf_gc_sweep_hook
  #define elf_backend_check_relocs                m32r_elf_check_relocs
  
+ #define elf_backend_create_dynamic_sections     m32r_elf_create_dynamic_sections
+ #define bfd_elf32_bfd_link_hash_table_create    m32r_elf_link_hash_table_create
+ #define elf_backend_size_dynamic_sections       m32r_elf_size_dynamic_sections
+ #define elf_backend_finish_dynamic_sections     m32r_elf_finish_dynamic_sections
+ #define elf_backend_adjust_dynamic_symbol       m32r_elf_adjust_dynamic_symbol
+ #define elf_backend_finish_dynamic_symbol       m32r_elf_finish_dynamic_symbol
+ #define elf_backend_reloc_type_class            m32r_elf_reloc_type_class
+ #define elf_backend_copy_indirect_symbol        m32r_elf_copy_indirect_symbol
+ 
  #define elf_backend_can_gc_sections             1
! /*#if !USE_REL
  #define elf_backend_rela_normal			1
+ #endif*/
+ #define elf_backend_can_refcount 1
+ #define elf_backend_want_got_plt 1
+ #define elf_backend_plt_readonly 1
+ #define elf_backend_want_plt_sym 0
+ #define elf_backend_got_header_size 12
+ 
+ #define elf_backend_may_use_rel_p       1
+ #ifdef USE_M32R_OLD_RELOC
+ #define elf_backend_default_use_rela_p  0
+ #define elf_backend_may_use_rela_p      0
+ #else
+ #define elf_backend_default_use_rela_p  1
+ #define elf_backend_may_use_rela_p      1
+ #define elf_backend_fake_sections       m32r_elf_fake_sections
  #endif
+ 
  #if 0 /* not yet */
  /* relax support */
  #define bfd_elf32_bfd_relax_section		m32r_elf_relax_section
***************
*** 2141,2143 ****
--- 4802,4821 ----
  #define elf_backend_special_sections		m32r_elf_special_sections
  
  #include "elf32-target.h"
+ 
+ #undef ELF_MAXPAGESIZE
+ #define ELF_MAXPAGESIZE         0x1000
+ 
+ #undef TARGET_BIG_SYM
+ #define TARGET_BIG_SYM          bfd_elf32_m32rlin_vec
+ #undef TARGET_BIG_NAME
+ #define TARGET_BIG_NAME         "elf32-m32r-linux"
+ #undef TARGET_LITTLE_SYM
+ #define TARGET_LITTLE_SYM       bfd_elf32_m32rlelin_vec
+ #undef TARGET_LITTLE_NAME
+ #define TARGET_LITTLE_NAME      "elf32-m32rle-linux"
+ #undef elf32_bed
+ #define elf32_bed               elf32_m32r_lin_bed
+ 
+ #include "elf32-target.h"
+ 
Index: bfd/reloc.c
===================================================================
RCS file: /cvs/src/src/bfd/reloc.c,v
retrieving revision 1.96
diff -c -r1.96 reloc.c
*** bfd/reloc.c	30 Nov 2003 18:40:41 -0000	1.96
--- bfd/reloc.c	18 Dec 2003 10:04:33 -0000
***************
*** 2911,2916 ****
--- 2911,2947 ----
  ENUMDOC
    This is a 16-bit reloc containing the small data area offset for use in
    add3, load, and store instructions.
+ ENUM
+   BFD_RELOC_M32R_GOT24
+ ENUMX
+   BFD_RELOC_M32R_26_PLTREL
+ ENUMX
+   BFD_RELOC_M32R_COPY
+ ENUMX
+   BFD_RELOC_M32R_GLOB_DAT
+ ENUMX
+   BFD_RELOC_M32R_JMP_SLOT
+ ENUMX
+   BFD_RELOC_M32R_RELATIVE
+ ENUMX
+   BFD_RELOC_M32R_GOTOFF
+ ENUMX
+   BFD_RELOC_M32R_GOTPC24
+ ENUMX
+   BFD_RELOC_M32R_GOT16_HI_ULO
+ ENUMX
+   BFD_RELOC_M32R_GOT16_HI_SLO
+ ENUMX
+   BFD_RELOC_M32R_GOT16_LO
+ ENUMX
+   BFD_RELOC_M32R_GOTPC_HI_ULO
+ ENUMX
+   BFD_RELOC_M32R_GOTPC_HI_SLO
+ ENUMX
+   BFD_RELOC_M32R_GOTPC_LO
+ ENUMDOC
+   For PIC.
+ 
  
  ENUM
    BFD_RELOC_V850_9_PCREL
Index: bfd/targets.c
===================================================================
RCS file: /cvs/src/src/bfd/targets.c,v
retrieving revision 1.102
diff -c -r1.102 targets.c
*** bfd/targets.c	30 Nov 2003 18:40:41 -0000	1.102
--- bfd/targets.c	18 Dec 2003 10:04:34 -0000
***************
*** 542,547 ****
--- 542,550 ----
  extern const bfd_target bfd_elf32_littlearm_vec;
  extern const bfd_target bfd_elf32_littlemips_vec;
  extern const bfd_target bfd_elf32_m32r_vec;
+ extern const bfd_target bfd_elf32_m32rle_vec;
+ extern const bfd_target bfd_elf32_m32rlin_vec;
+ extern const bfd_target bfd_elf32_m32rlelin_vec;
  extern const bfd_target bfd_elf32_m68hc11_vec;
  extern const bfd_target bfd_elf32_m68hc12_vec;
  extern const bfd_target bfd_elf32_m68k_vec;
***************
*** 831,836 ****
--- 834,842 ----
  	&bfd_elf32_littlearm_vec,
  	&bfd_elf32_littlemips_vec,
  	&bfd_elf32_m32r_vec,
+         &bfd_elf32_m32rle_vec,
+         &bfd_elf32_m32rlin_vec,
+         &bfd_elf32_m32rlelin_vec,
  	&bfd_elf32_m68hc11_vec,
  	&bfd_elf32_m68hc12_vec,
  	&bfd_elf32_m68k_vec,
Index: gas/configure.in
===================================================================
RCS file: /cvs/src/src/gas/configure.in,v
retrieving revision 1.145
diff -c -r1.145 configure.in
*** gas/configure.in	3 Dec 2003 15:07:16 -0000	1.145
--- gas/configure.in	18 Dec 2003 10:04:36 -0000
***************
*** 164,169 ****
--- 164,171 ----
        sparc*)		cpu_type=sparc arch=sparclite ;; # ??? See tc-sparc.c.
        v850*)		cpu_type=v850 ;;
        xtensa*)		cpu_type=xtensa arch=xtensa ;;
+       m32r)             cpu_type=m32r target_cpu=m32r endian=big ;;
+       m32rle)           cpu_type=m32r target_cpu=m32r endian=little ;;
        *)		cpu_type=${cpu} ;;
      esac
  
***************
*** 337,343 ****
  
        iq2000-*-elf)         		fmt=elf bfd_gas=yes ;;
  
!       m32r-*-*)				fmt=elf ;;
  
        m68hc11-*-* | m6811-*-*)		fmt=elf ;;
        m68hc12-*-* | m6812-*-*)		fmt=elf ;;
--- 339,346 ----
  
        iq2000-*-elf)         		fmt=elf bfd_gas=yes ;;
  
!       m32r-*-elf*)			fmt=elf ;;
!       m32r-*-linux*)			fmt=elf em=linux;;
  
        m68hc11-*-* | m6811-*-*)		fmt=elf ;;
        m68hc12-*-* | m6812-*-*)		fmt=elf ;;
Index: gas/config/tc-m32r.c
===================================================================
RCS file: /cvs/src/src/gas/config/tc-m32r.c,v
retrieving revision 1.33
diff -c -r1.33 tc-m32r.c
*** gas/config/tc-m32r.c	17 Dec 2003 09:41:06 -0000	1.33
--- gas/config/tc-m32r.c	18 Dec 2003 10:04:37 -0000
***************
*** 70,75 ****
--- 70,78 ----
     alignment request.  */
  static int seen_relaxable_p = 0;
  
+ /* Non-zero if we are generating PIC code.  */
+ int pic_code;
+ 
  /* Non-zero if -relax specified, in which case sufficient relocs are output
     for the linker to do relaxing.
     We do simple forms of relaxing internally, but they are always done.
***************
*** 194,200 ****
      gas_cgen_cpu_desc->machs = mach_table[on].mach_flags;
  }
  
! #define M32R_SHORTOPTS "O"
  
  const char *md_shortopts = M32R_SHORTOPTS;
  
--- 197,203 ----
      gas_cgen_cpu_desc->machs = mach_table[on].mach_flags;
  }
  
! #define M32R_SHORTOPTS "O::K:"
  
  const char *md_shortopts = M32R_SHORTOPTS;
  
***************
*** 362,367 ****
--- 365,377 ----
        warn_unmatched_high = 0;
        break;
  
+     case 'K':
+       if (strcmp (arg, "PIC") != 0)
+         as_warn (_("Unrecognized option following -K"));
+       else
+         pic_code = 1;
+       break;
+ 
  #if 0
      /* Not supported yet.  */
      case OPTION_RELAX:
***************
*** 436,441 ****
--- 446,454 ----
    fprintf (stream, _("\
    -Wnuh                   synonym for -no-warn-unmatched-high\n"));
  
+   fprintf (stream, _("\
+   -KPIC                   generate PIC\n"));
+ 
  #if 0
    fprintf (stream, _("\
    -relax                 create linker relaxable code\n"));
***************
*** 558,564 ****
      }
  
    symbol_table_insert (symbolP);
!   if (S_IS_DEFINED (symbolP) && S_GET_SEGMENT (symbolP) != reg_section)
      /* xgettext:c-format */
      as_bad (_("symbol `%s' already defined"), S_GET_NAME (symbolP));
  
--- 571,579 ----
      }
  
    symbol_table_insert (symbolP);
!   if (S_IS_DEFINED (symbolP) && (S_GET_SEGMENT (symbolP) != reg_section
!                                  || S_IS_EXTERNAL (symbolP)
!                                  || S_IS_WEAK (symbolP)))
      /* xgettext:c-format */
      as_bad (_("symbol `%s' already defined"), S_GET_NAME (symbolP));
  
***************
*** 1710,1716 ****
       However, we can't finish the fragment here and emit the reloc as insn
       alignment requirements may move the insn about.  */
  
!   if (S_GET_SEGMENT (fragP->fr_symbol) != segment)
      {
  #if 0
        int old_fr_fix = fragP->fr_fix;
--- 1725,1733 ----
       However, we can't finish the fragment here and emit the reloc as insn
       alignment requirements may move the insn about.  */
  
!   if (S_GET_SEGMENT (fragP->fr_symbol) != segment
!       || S_IS_EXTERNAL (fragP->fr_symbol)
!       || S_IS_WEAK (fragP->fr_symbol))
      {
  #if 0
        int old_fr_fix = fragP->fr_fix;
***************
*** 1816,1827 ****
        abort ();
      }
  
!   if (S_GET_SEGMENT (fragP->fr_symbol) != sec)
      {
        /* Symbol must be resolved by linker.  */
        if (fragP->fr_offset & 3)
  	as_warn (_("Addend to unresolved symbol not on word boundary."));
!       addend = fragP->fr_offset >> 2;
      }
    else
      {
--- 1833,1850 ----
        abort ();
      }
  
!   if (S_GET_SEGMENT (fragP->fr_symbol) != sec
!       || S_IS_EXTERNAL (fragP->fr_symbol)
!       || S_IS_WEAK (fragP->fr_symbol))
      {
        /* Symbol must be resolved by linker.  */
        if (fragP->fr_offset & 3)
  	as_warn (_("Addend to unresolved symbol not on word boundary."));
! #ifdef USE_M32R_OLD_RELOC
!       addend = fragP->fr_offset >> 2; /* Old M32R used USE_REL. */
! #else
!       addend = 0;
! #endif
      }
    else
      {
***************
*** 1833,1839 ****
    /* Create a relocation for symbols that must be resolved by the linker.
       Otherwise output the completed insn.  */
  
!   if (S_GET_SEGMENT (fragP->fr_symbol) != sec)
      {
        assert (fragP->fr_subtype != 1);
        assert (fragP->fr_cgen.insn != 0);
--- 1856,1864 ----
    /* Create a relocation for symbols that must be resolved by the linker.
       Otherwise output the completed insn.  */
  
!   if (S_GET_SEGMENT (fragP->fr_symbol) != sec
!       || S_IS_EXTERNAL (fragP->fr_symbol)
!       || S_IS_WEAK (fragP->fr_symbol))
      {
        assert (fragP->fr_subtype != 1);
        assert (fragP->fr_cgen.insn != 0);
***************
*** 1874,1880 ****
  {
    if (fixP->fx_addsy != (symbolS *) NULL
        && (! S_IS_DEFINED (fixP->fx_addsy)
! 	  || S_GET_SEGMENT (fixP->fx_addsy) != sec))
      {
        /* The symbol is undefined (or is defined but not in this section).
  	 Let the linker figure it out.  */
--- 1899,1907 ----
  {
    if (fixP->fx_addsy != (symbolS *) NULL
        && (! S_IS_DEFINED (fixP->fx_addsy)
! 	  || S_GET_SEGMENT (fixP->fx_addsy) != sec
!           || S_IS_EXTERNAL (fixP->fx_addsy)
!           || S_IS_WEAK (fixP->fx_addsy)))
      {
        /* The symbol is undefined (or is defined but not in this section).
  	 Let the linker figure it out.  */
***************
*** 2189,2194 ****
--- 2216,2238 ----
    else
      reloc_type = fixP->fx_r_type;
  
+   if (fixP->fx_addsy == NULL)
+     return 1;
+ 
+   /* Prevent all adjustments to global symbols.  */
+   if (S_IS_EXTERN (fixP->fx_addsy))
+     return 0;
+   if (S_IS_WEAK (fixP->fx_addsy))
+     return 0;
+ 
+   if (pic_code
+       && (reloc_type == BFD_RELOC_M32R_24
+           || reloc_type == BFD_RELOC_M32R_26_PCREL
+           || reloc_type == BFD_RELOC_M32R_HI16_SLO
+           || reloc_type == BFD_RELOC_M32R_HI16_ULO
+           || reloc_type == BFD_RELOC_M32R_LO16))
+     return 0;
+ 
    /* We need the symbol name for the VTABLE entries.  */
    if (reloc_type == BFD_RELOC_VTABLE_INHERIT
        || reloc_type == BFD_RELOC_VTABLE_ENTRY)
***************
*** 2203,2206 ****
--- 2247,2346 ----
    if (use_parallel)
      m32r_flags |= E_M32R_HAS_PARALLEL;
    elf_elfheader (stdoutput)->e_flags |= m32r_flags;
+ }
+ 
+ #define GOT_NAME "_GLOBAL_OFFSET_TABLE_"
+  
+ /* Translate internal representation of relocation info to BFD target
+    format. */
+ arelent *
+ tc_gen_reloc (section, fixP)
+      asection * section;
+      fixS *     fixP;
+ {
+   arelent * reloc;
+   bfd_reloc_code_real_type code;
+  
+   reloc = (arelent *) xmalloc (sizeof (arelent));
+  
+   reloc->sym_ptr_ptr = (asymbol **) xmalloc (sizeof (asymbol *));
+   *reloc->sym_ptr_ptr = symbol_get_bfdsym (fixP->fx_addsy);
+   reloc->address = fixP->fx_frag->fr_address + fixP->fx_where;
+  
+   code = fixP->fx_r_type;
+   if (pic_code)
+     {
+ #ifdef DEBUG_PIC
+ printf("%s",bfd_get_reloc_code_name(code));
+ #endif
+       switch (code)
+         {
+         case BFD_RELOC_M32R_26_PCREL:
+             code = BFD_RELOC_M32R_26_PLTREL;
+           break;
+         case BFD_RELOC_M32R_24:
+           if (fixP->fx_addsy != NULL
+               && strcmp (S_GET_NAME (fixP->fx_addsy), GOT_NAME) == 0)
+             code = BFD_RELOC_M32R_GOTPC24;
+           else
+             code = BFD_RELOC_M32R_GOT24;
+           break;
+         case BFD_RELOC_M32R_HI16_ULO:
+           if (fixP->fx_addsy != NULL
+               && strcmp (S_GET_NAME (fixP->fx_addsy), GOT_NAME) == 0)
+             code = BFD_RELOC_M32R_GOTPC_HI_ULO;
+           else
+             code = BFD_RELOC_M32R_GOT16_HI_ULO;
+           break;
+         case BFD_RELOC_M32R_HI16_SLO:
+           if (fixP->fx_addsy != NULL
+               && strcmp (S_GET_NAME (fixP->fx_addsy), GOT_NAME) == 0)
+             code = BFD_RELOC_M32R_GOTPC_HI_SLO;
+           else
+             code = BFD_RELOC_M32R_GOT16_HI_SLO;
+           break;
+         case BFD_RELOC_M32R_LO16:
+           if (fixP->fx_addsy != NULL
+               && strcmp (S_GET_NAME (fixP->fx_addsy), GOT_NAME) == 0)
+             code = BFD_RELOC_M32R_GOTPC_LO;
+           else
+             code = BFD_RELOC_M32R_GOT16_LO;
+           break;
+         default:
+           break;
+         }
+ #ifdef DEBUG_PIC
+ printf(" => %s",bfd_get_reloc_code_name(code));
+ #endif
+     }
+  
+   reloc->howto = bfd_reloc_type_lookup (stdoutput, code);
+ #ifdef DEBUG_PIC
+ printf(" => %s\n",reloc->howto->name);
+ #endif
+   if (reloc->howto == (reloc_howto_type *) NULL)
+     {
+       as_bad_where (fixP->fx_file, fixP->fx_line,
+             _("internal error: can't export reloc type %d (`%s')"),
+             fixP->fx_r_type, bfd_get_reloc_code_name (code));
+       return NULL;
+     }
+  
+   /* Use fx_offset for these cases */
+   if (   fixP->fx_r_type == BFD_RELOC_VTABLE_ENTRY
+       || fixP->fx_r_type == BFD_RELOC_VTABLE_INHERIT)
+     reloc->addend  = fixP->fx_offset;
+   else if (!pic_code
+            && fixP->fx_pcrel
+            && fixP->fx_addsy != NULL
+            && (S_GET_SEGMENT(fixP->fx_addsy) != section)
+            && S_IS_DEFINED (fixP->fx_addsy)
+            && ! S_IS_EXTERNAL(fixP->fx_addsy)
+            && ! S_IS_WEAK(fixP->fx_addsy))
+     /* already used fx_offset in the opcode field itseld. */
+     reloc->addend  = 0;
+   else
+     reloc->addend  = fixP->fx_addnumber;
+  
+   return reloc;
  }
Index: gas/config/tc-m32r.h
===================================================================
RCS file: /cvs/src/src/gas/config/tc-m32r.h,v
retrieving revision 1.10
diff -c -r1.10 tc-m32r.h
*** gas/config/tc-m32r.h	3 Dec 2003 17:38:45 -0000	1.10
--- gas/config/tc-m32r.h	18 Dec 2003 10:04:37 -0000
***************
*** 87,100 ****
     HI16 relocs and queue them up for later sorting.  */
  #define md_cgen_record_fixup_exp m32r_cgen_record_fixup_exp
  
! #define tc_gen_reloc gas_cgen_tc_gen_reloc
  
  #define tc_frob_file_before_fix() m32r_frob_file ()
  extern void m32r_frob_file PARAMS ((void));
  
  /* No shared lib support, so we don't need to ensure externally
!    visible symbols can be overridden.  */
! #define EXTERN_FORCE_RELOC 0
  
  /* When relaxing, we need to emit various relocs we otherwise wouldn't.  */
  #define TC_FORCE_RELOCATION(fix) m32r_force_relocation (fix)
--- 87,117 ----
     HI16 relocs and queue them up for later sorting.  */
  #define md_cgen_record_fixup_exp m32r_cgen_record_fixup_exp
  
! /* #define tc_gen_reloc gas_cgen_tc_gen_reloc */
! 
! #define TC_HANDLES_FX_DONE
! 
! extern int pic_code;
! 
! extern bfd_boolean m32r_fix_adjustable PARAMS ((struct fix *));
! 
! /* This arranges for gas/write.c to not apply a relocation if
!    obj_fix_adjustable() says it is not adjustable.  */
! #define TC_FIX_ADJUSTABLE(fixP) obj_fix_adjustable (fixP)
! 
! #define TC_RELOC_RTSYM_LOC_FIXUP(FIX)                           \
!    ((FIX)->fx_addsy == NULL                                     \
!     || (! S_IS_EXTERNAL ((FIX)->fx_addsy)                       \
!         && ! S_IS_WEAK ((FIX)->fx_addsy)                        \
!         && S_IS_DEFINED ((FIX)->fx_addsy)                       \
!         && ! S_IS_COMMON ((FIX)->fx_addsy)))
  
  #define tc_frob_file_before_fix() m32r_frob_file ()
  extern void m32r_frob_file PARAMS ((void));
  
  /* No shared lib support, so we don't need to ensure externally
!    visible symbols can be overridden.
! #define EXTERN_FORCE_RELOC 0 */
  
  /* When relaxing, we need to emit various relocs we otherwise wouldn't.  */
  #define TC_FORCE_RELOCATION(fix) m32r_force_relocation (fix)
Index: gdb/configure.host
===================================================================
RCS file: /cvs/src/src/gdb/configure.host,v
retrieving revision 1.61
diff -c -r1.61 configure.host
*** gdb/configure.host	1 Dec 2003 21:10:46 -0000	1.61
--- gdb/configure.host	18 Dec 2003 10:04:39 -0000
***************
*** 22,27 ****
--- 22,28 ----
  sh*)			gdb_host_cpu=sh ;;
  x86_64*)		gdb_host_cpu=i386 ;;
  xscale*)		gdb_host_cpu=arm ;;
+ m32r*)			gdb_host_cpu=m32r ;;
  *)			gdb_host_cpu=$host_cpu ;;
  
  esac
***************
*** 146,150 ****
--- 147,153 ----
  x86_64-*-linux*)	gdb_host=x86-64linux ;;
  x86_64-*-freebsd*)	gdb_host=fbsd64 ;;
  x86_64-*-netbsd*)	gdb_host=nbsd64 ;;
+ 
+ m32r*-*-linux*)          gdb_host=linux ;;
  
  esac
Index: include/elf/m32r.h
===================================================================
RCS file: /cvs/src/src/include/elf/m32r.h,v
retrieving revision 1.6
diff -c -r1.6 m32r.h
*** include/elf/m32r.h	3 Dec 2003 17:38:48 -0000	1.6
--- include/elf/m32r.h	18 Dec 2003 10:04:41 -0000
***************
*** 25,42 ****
  /* Relocations.  */
  START_RELOC_NUMBERS (elf_m32r_reloc_type)
    RELOC_NUMBER (R_M32R_NONE, 0)
!   RELOC_NUMBER (R_M32R_16, 1)
!   RELOC_NUMBER (R_M32R_32, 2)
!   RELOC_NUMBER (R_M32R_24, 3)
!   RELOC_NUMBER (R_M32R_10_PCREL, 4)
!   RELOC_NUMBER (R_M32R_18_PCREL, 5)
!   RELOC_NUMBER (R_M32R_26_PCREL, 6)
!   RELOC_NUMBER (R_M32R_HI16_ULO, 7)
!   RELOC_NUMBER (R_M32R_HI16_SLO, 8)
!   RELOC_NUMBER (R_M32R_LO16, 9)
!   RELOC_NUMBER (R_M32R_SDA16, 10)
!   RELOC_NUMBER (R_M32R_GNU_VTINHERIT, 11)
!   RELOC_NUMBER (R_M32R_GNU_VTENTRY, 12)
  END_RELOC_NUMBERS (R_M32R_max)
  
  /* Processor specific section indices.  These sections do not actually
--- 25,72 ----
  /* Relocations.  */
  START_RELOC_NUMBERS (elf_m32r_reloc_type)
    RELOC_NUMBER (R_M32R_NONE, 0)
!   /* REL relocations */
!   RELOC_NUMBER (R_M32R_16, 1)		 /* For backwards compatibility. */
!   RELOC_NUMBER (R_M32R_32, 2)		 /* For backwards compatibility. */
!   RELOC_NUMBER (R_M32R_24, 3)		 /* For backwards compatibility. */
!   RELOC_NUMBER (R_M32R_10_PCREL, 4)	 /* For backwards compatibility. */
!   RELOC_NUMBER (R_M32R_18_PCREL, 5)	 /* For backwards compatibility. */
!   RELOC_NUMBER (R_M32R_26_PCREL, 6)	 /* For backwards compatibility. */
!   RELOC_NUMBER (R_M32R_HI16_ULO, 7)	 /* For backwards compatibility. */
!   RELOC_NUMBER (R_M32R_HI16_SLO, 8)	 /* For backwards compatibility. */
!   RELOC_NUMBER (R_M32R_LO16, 9)		 /* For backwards compatibility. */
!   RELOC_NUMBER (R_M32R_SDA16, 10)	 /* For backwards compatibility. */
!   RELOC_NUMBER (R_M32R_GNU_VTINHERIT, 11)/* For backwards compatibility. */
!   RELOC_NUMBER (R_M32R_GNU_VTENTRY, 12)	 /* For backwards compatibility. */
! 
!   /* RELA relocations */
!   RELOC_NUMBER (R_M32R_16_RELA, 33)
!   RELOC_NUMBER (R_M32R_32_RELA, 34)
!   RELOC_NUMBER (R_M32R_24_RELA, 35)
!   RELOC_NUMBER (R_M32R_10_PCREL_RELA, 36)
!   RELOC_NUMBER (R_M32R_18_PCREL_RELA, 37)
!   RELOC_NUMBER (R_M32R_26_PCREL_RELA, 38)
!   RELOC_NUMBER (R_M32R_HI16_ULO_RELA, 39)
!   RELOC_NUMBER (R_M32R_HI16_SLO_RELA, 40)
!   RELOC_NUMBER (R_M32R_LO16_RELA, 41)
!   RELOC_NUMBER (R_M32R_SDA16_RELA, 42)
!   RELOC_NUMBER (R_M32R_RELA_GNU_VTINHERIT, 43)
!   RELOC_NUMBER (R_M32R_RELA_GNU_VTENTRY, 44)
!                                                                                 
!   RELOC_NUMBER (R_M32R_GOT24, 48)
!   RELOC_NUMBER (R_M32R_26_PLTREL, 49)
!   RELOC_NUMBER (R_M32R_COPY, 50)
!   RELOC_NUMBER (R_M32R_GLOB_DAT, 51)
!   RELOC_NUMBER (R_M32R_JMP_SLOT, 52)
!   RELOC_NUMBER (R_M32R_RELATIVE, 53)
!   RELOC_NUMBER (R_M32R_GOTOFF, 54)
!   RELOC_NUMBER (R_M32R_GOTPC24, 55)
!   RELOC_NUMBER (R_M32R_GOT16_HI_ULO, 56)
!   RELOC_NUMBER (R_M32R_GOT16_HI_SLO, 57)
!   RELOC_NUMBER (R_M32R_GOT16_LO, 58)
!   RELOC_NUMBER (R_M32R_GOTPC_HI_ULO, 59)
!   RELOC_NUMBER (R_M32R_GOTPC_HI_SLO, 60)
!   RELOC_NUMBER (R_M32R_GOTPC_LO, 61)
  END_RELOC_NUMBERS (R_M32R_max)
  
  /* Processor specific section indices.  These sections do not actually
Index: ld/Makefile.am
===================================================================
RCS file: /cvs/src/src/ld/Makefile.am,v
retrieving revision 1.147
diff -c -r1.147 Makefile.am
*** ld/Makefile.am	4 Dec 2003 12:09:25 -0000	1.147
--- ld/Makefile.am	18 Dec 2003 10:04:41 -0000
***************
*** 230,235 ****
--- 230,238 ----
  	ei386pe_posix.o \
  	elnk960.o \
  	em32relf.o \
+ 	em32rlelf.o \
+ 	em32relf_linux.o \
+ 	em32rlelf_linux.o \
  	em68hc11elf.o \
  	em68hc11elfb.o \
  	em68hc12elf.o \
***************
*** 603,608 ****
--- 606,620 ----
  em32relf.c: $(srcdir)/emulparams/m32relf.sh \
    $(srcdir)/emultempl/elf32.em $(srcdir)/scripttempl/elf.sc ${GEN_DEPENDS}
  	${GENSCRIPTS} m32relf "$(tdir_m32r)"
+ em32rlelf.c: $(srcdir)/emulparams/m32rlelf.sh \
+   $(srcdir)/emultempl/elf32.em $(srcdir)/scripttempl/elf.sc ${GEN_DEPENDS}
+ 	${GENSCRIPTS} m32rlelf "$(tdir_m32rlelf)"
+ em32relf_linux.c: $(srcdir)/emulparams/m32relf_linux.sh \
+   $(srcdir)/emultempl/elf32.em $(srcdir)/scripttempl/elf.sc ${GEN_DEPENDS}
+ 	${GENSCRIPTS} m32relf_linux "$(tdir_m32relf_linux)"
+ em32rlelf_linux.c: $(srcdir)/emulparams/m32rlelf_linux.sh \
+   $(srcdir)/emultempl/elf32.em $(srcdir)/scripttempl/elf.sc ${GEN_DEPENDS}
+ 	${GENSCRIPTS} m32rlelf_linux "$(tdir_m32rlelf_linux)"
  eelf32_sparc.c: $(srcdir)/emulparams/elf32_sparc.sh \
    $(srcdir)/emultempl/elf32.em $(srcdir)/scripttempl/elf.sc ${GEN_DEPENDS}
  	${GENSCRIPTS} elf32_sparc "$(tdir_elf32_sparc)"
Index: ld/configure.tgt
===================================================================
RCS file: /cvs/src/src/ld/configure.tgt,v
retrieving revision 1.141
diff -c -r1.141 configure.tgt
*** ld/configure.tgt	3 Dec 2003 15:07:17 -0000	1.141
--- ld/configure.tgt	18 Dec 2003 10:04:41 -0000
***************
*** 115,121 ****
  ia64-*-netbsd*)		targ_emul=elf64_ia64 ;;
  ia64-*-linux*)		targ_emul=elf64_ia64 ;;
  ia64-*-aix*)		targ_emul=elf64_aix ;;
! m32r-*-*)		targ_emul=m32relf ;;
  m68hc11-*-*|m6811-*-*)	targ_emul=m68hc11elf 
  			targ_extra_emuls="m68hc11elfb m68hc12elf m68hc12elfb" ;;
  m68hc12-*-*|m6812-*-*)	targ_emul=m68hc12elf 
--- 115,124 ----
  ia64-*-netbsd*)		targ_emul=elf64_ia64 ;;
  ia64-*-linux*)		targ_emul=elf64_ia64 ;;
  ia64-*-aix*)		targ_emul=elf64_aix ;;
! m32r*le-*-elf*)         targ_emul=m32rlelf ;;
! m32r*-*-elf*)           targ_emul=m32relf ;;
! m32r*le-*-linux-gnu*)   targ_emul=m32rlelf_linux ;;
! m32r*-*-linux-gnu*)     targ_emul=m32relf_linux ;;
  m68hc11-*-*|m6811-*-*)	targ_emul=m68hc11elf 
  			targ_extra_emuls="m68hc11elfb m68hc12elf m68hc12elfb" ;;
  m68hc12-*-*|m6812-*-*)	targ_emul=m68hc12elf 
Index: sim/common/sim-core.c
===================================================================
RCS file: /cvs/src/src/sim/common/sim-core.c,v
retrieving revision 1.3
diff -c -r1.3 sim-core.c
*** sim/common/sim-core.c	23 Nov 2002 01:12:05 -0000	1.3
--- sim/common/sim-core.c	18 Dec 2003 10:04:47 -0000
***************
*** 801,806 ****
--- 801,825 ----
  }
  #endif
  
+ #if EXTERN_SIM_CORE_P
+ void *
+ sim_core_trans_addr (SIM_DESC sd,
+                      sim_cpu *cpu,
+                      unsigned map,
+                      address_word addr)
+ {
+   sim_core_common *core = (cpu == NULL ? &STATE_CORE (sd)->common : &CPU_CORE (cpu)->common);
+   sim_core_mapping *mapping =
+     sim_core_find_mapping (core, map,
+                            addr, /*nr-bytes*/1,
+                            write_transfer,
+                            0 /*dont-abort*/, NULL, NULL_CIA);
+   if (mapping == NULL)
+     return NULL;
+   return sim_core_translate(mapping, addr);
+ }
+ #endif
+ 
  
  
  /* define the read/write 1/2/4/8/16/word functions */
Index: sim/m32r/configure.in
===================================================================
RCS file: /cvs/src/src/sim/m32r/configure.in,v
retrieving revision 1.1.1.1
diff -c -r1.1.1.1 configure.in
*** sim/m32r/configure.in	16 Apr 1999 01:35:05 -0000	1.1.1.1
--- sim/m32r/configure.in	18 Dec 2003 10:04:47 -0000
***************
*** 14,17 ****
--- 14,31 ----
  SIM_AC_OPTION_INLINE()
  SIM_AC_OPTION_CGEN_MAINT
  
+   case "${target_alias}" in
+   m32r*-linux*)
+     traps_obj=traps-linux.o
+     sim_extra_cflags="-DM32R_LINUX"
+     ;;
+   *)
+     traps_obj=traps.o
+     sim_extra_cflags="-DM32R_ELF"
+     ;;
+   esac
+ AC_SUBST(traps_obj)
+ AC_SUBST(sim_extra_cflags)
+ 
+ 
  SIM_AC_OUTPUT
Index: sim/m32r/sim-if.c
===================================================================
RCS file: /cvs/src/src/sim/m32r/sim-if.c,v
retrieving revision 1.6
diff -c -r1.6 sim-if.c
*** sim/m32r/sim-if.c	11 Dec 2003 11:33:44 -0000	1.6
--- sim/m32r/sim-if.c	18 Dec 2003 10:04:47 -0000
***************
*** 214,219 ****
--- 214,226 ----
      addr = 0;
    sim_pc_set (current_cpu, addr);
  
+ #ifdef M32R_LINUX
+   m32rbf_h_cr_set (current_cpu,
+                     m32r_decode_gdb_ctrl_regnum(SPI_REGNUM), 0x1f00000);
+   m32rbf_h_cr_set (current_cpu,
+                     m32r_decode_gdb_ctrl_regnum(SPU_REGNUM), 0x1f00000);
+ #endif
+ 
  #if 0
    STATE_ARGV (sd) = sim_copy_argv (argv);
    STATE_ENVP (sd) = sim_copy_argv (envp);
Index: sim/m32r/sim-main.h
===================================================================
RCS file: /cvs/src/src/sim/m32r/sim-main.h,v
retrieving revision 1.5
diff -c -r1.5 sim-main.h
*** sim/m32r/sim-main.h	11 Dec 2003 11:33:44 -0000	1.5
--- sim/m32r/sim-main.h	18 Dec 2003 10:04:47 -0000
***************
*** 85,90 ****
--- 85,94 ----
  		  (TRANSFER), (ERROR))
  
  /* Default memory size.  */
+ #ifdef M32R_LINUX
+ #define M32R_DEFAULT_MEM_SIZE 0x2000000 /* 32M */
+ #else
  #define M32R_DEFAULT_MEM_SIZE 0x800000 /* 8M */
+ #endif
  
  #endif /* SIM_MAIN_H */
